package com.retrospective.ui.regserviceclient;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.centeractive.licenseclient.EvaluationKey;
import com.centeractive.licenseclient.ProductInformation;
import com.centeractive.licenseclient.dialog.DialogFactory;
import com.centeractive.licenseclient.dialog.RegistrationDialog;

public class SWTDialogFactory implements DialogFactory {

    private final Shell shell;

    public SWTDialogFactory(Shell shell) {
        this.shell = shell;
    }

    @Override
    public RegistrationDialog createRegistrationDialog(ProductInformation productInfo, EvaluationKey evalKey) {
        return new SWTRegistrationDialog(productInfo, shell, evalKey);
    }

    public static Label createLabel(final Composite parent, final String text) {
        return createLabel(parent, text, SWT.NONE);
    }

    public static Label createLabel(final Composite parent, final String text, final int style) {
        final Label label = new Label(parent, style);
        if (text != null) {
            label.setText(text);
        }
        return label;
    }

    public static Text createText(final Composite parent, final String value, final int style) {
        final Text text = new Text(parent, SWT.BORDER | SWT.FLAT | style);
        if (value != null) {
            text.setText(value);
        }
        return text;
    }

}
