# import SearchOptimizationLogger.sh
# import SearchOptimizationSliceDateCheck.sh
# import SearchOptimizationFindRange.sh
# import SearchOptimizationSliceSearching.sh






	GREP_0947=500000

	GREP_0948=$GREP_0947

	GREP_0949=65000

	GREP_0950=32500




GREP_1012()
{
	if [ "$DATE_TIME_FRAMES_COUNT" -gt 1 ] ; then
		GREP_1189 "Multiple time search criteria are currently not supported by search optimization, thus the optimization was aborted"
		GREP_0986
	else
		if [ "$GREP_0198" -eq 0 ] || [ "$GREP_0199" = "AND" ] ; then
			GREP_0980=$(GREP_0943 "$GREP_1154")
			if [ $GREP_0980 -ge $GREP_0947 ]; then
				GREP_1168 "Started search optimization on File Size: $GREP_0980"
				GREP_1011
			else
				GREP_1188 "Search optimization aborted because File Size ($GREP_0980) is less than $GREP_0947 bytes"
				GREP_0986
			fi
		else
			GREP_1169 "Search optimization aborted because time search criteria is OR-joined with text criteria"
			GREP_0986
		fi
	fi
}



GREP_1011()
{
	GREP_0975=0
	GREP_0974="END"
	if [ -z "$GREP_0959" ] ; then
		GREP_1168 "_find_range_init_ -z _DATE_FROM_BORDER_EXIST_ reversed _init_ order"
		GREP_1007
		GREP_1003
	else
		GREP_1168 "_find_range_init_ -n _DATE_FROM_BORDER_EXIST_ _regular_ _init_ order"
		GREP_1003
		GREP_1007
	fi
	GREP_1172
}



GREP_1003()
{
	if [ -n "$GREP_0977" ] && [ -z "$GREP_0959" ] ; then
		GREP_0976="0"
		GREP_1168 "_find_range_init_beginning_ looking at file beginning aborted"
		return
	fi
	GREP_1000
	GREP_1168 "_find_range_init_beginning_ _slice_date_check_range_"
	GREP_0994
	if [ $? -ne 0 ] ; then
		GREP_1170 "Search optimization sanitization failed on the first 64 kb of file. Failure reason: $GREP_0966"
		if [ -n "$GREP_0959" ] ; then
			GREP_0979="true"
		fi
		GREP_0976=0
		return
	fi
	if [ -n "$GREP_0968" ] ; then
		GREP_1001
	else
		GREP_1002
	fi
}


GREP_1000()
{
	GREP_0971=0
}

GREP_1001()
{
	if [ "$GREP_0968" = "BEFORE" ] ; then
		GREP_1169 "During time range optimization, the file was skipped because its entries have dates out of the range of time search criteria (criteria dates are before file entries dates)"
		GREP_0985
	elif [ "$GREP_0968" = "INSIDE" ] ; then
		GREP_0974=$GREP_0949
		GREP_1168 "_find_range_init_beginning_ _RANGE_HINT_ = INSIDE _search_slice_"
		GREP_0989
	else
		GREP_1168 "_find_range_init_beginning_ _RANGE_HINT_ = AFTER ... whole file should be searched"
	fi
}

GREP_1002()
{
	if [ "$GREP_0923" = "BEFORE" ] && [ "$GREP_0924" = "INSIDE" ] ; then
		GREP_0974=$GREP_0949
		GREP_1168 "_find_range_init_beginning_ _TO_HINT_=INSIDE _search_slice_"
		GREP_0989
	elif ( [ "$GREP_0923" = "BEFORE" ] || [ "$GREP_0923" = "INSIDE" ] ) && [ "$GREP_0924" = "AFTER" ] ; then
		GREP_1168 "_find_range_init_beginning_ found _FROM_FINAL_=0"
		GREP_0976=0
		if [ "$GREP_0923" = "INSIDE" ] ; then
			GREP_1168 "_find_range_init_beginning_ _NEEDS_LOCAL_FILTER_"
			GREP_0978="true"
		fi
	else
		GREP_1171 "Illegal _FROM_HINT_: $GREP_0923 and _TO_HINT_: $GREP_0924 combination at file beginning"
	fi
}



GREP_1007()
{
	if [ -n "$GREP_0976" ] && [ -z "$GREP_0960" ]; then
		GREP_0977="END"
		GREP_1168 "_find_range_init_end_ looking at file end aborted"
		return
	fi
	GREP_1004
	GREP_1168 "_find_range_init_end_ _slice_date_check_range_"
	GREP_0994
	if [ $? -ne 0 ] ; then
		GREP_1170 "Search optimization sanitization failed on the last 64 kb of file. Failure reason: $GREP_0966"
		if [ -n "$GREP_0960" ] ; then
			GREP_0979="true"
		fi
		GREP_0977="END"
		return
	fi
	if [ -n "$GREP_0968" ] ; then
		GREP_1005
	else
		GREP_1006
	fi
}

GREP_1004()
{
	GREP_0971=$(( GREP_0980 - GREP_0949 ))
}

GREP_1005()
{
	if [ "$GREP_0968" = "AFTER" ] ; then
		GREP_1169 "During time range optimization, the file was skipped because its entries have dates out of the range of time search criteria (criteria dates are after file entries dates)"
		GREP_0985
	elif [ "$GREP_0968" = "INSIDE" ] ; then
		GREP_0975=$GREP_0971
		GREP_1168 "_find_range_init_end_ _RANGE_HINT_=INSIDE _search_slice_"
		GREP_0989
	else
		GREP_1168 "_find_range_init_end_ _RANGE_HINT_ = BEFORE ... whole file should be searched"
	fi
}

GREP_1006()
{
	if [ "$GREP_0923" = "BEFORE" ] && ( [ "$GREP_0924" = "INSIDE" ] || [ "$GREP_0924" = "AFTER" ] ) ; then
		GREP_1168 "_find_range_init_end_ found _TO_FINAL_=END"
		GREP_0977="END"
		if [ "$GREP_0924" = "INSIDE" ] ; then
			GREP_1168 "_find_range_init_end_ _NEEDS_LOCAL_FILTER_"
			GREP_0978="true"
		fi
	elif [ "$GREP_0923" = "INSIDE" ] && [ "$GREP_0924" = "AFTER" ] ; then
		GREP_0975=$GREP_0971
		GREP_1168 "_find_range_init_end_ _FROM_HINT_=INSIDE _search_slice_"
		GREP_0989
	else
		GREP_1171 "Illegal _FROM_HINT_: $GREP_0923 and _TO_HINT_: $GREP_0924 combination at file end"
	fi
}







GREP_1172()
{
	if [ -n "$GREP_0976" ] && [ -n "$GREP_0977" ] ; then
		GREP_1008
	elif [ -n "$GREP_0976" ] ; then
		GREP_1009
	elif [ -n "$GREP_0977" ] ; then
		GREP_1010
	else
		GREP_0975=0
		GREP_0974=$GREP_0980
		GREP_1168 "_find_range_init_ _find_range_"
		GREP_0999
		GREP_1168 "_find_range_init_ _search_slice_"
		GREP_0989
	fi
}

GREP_1008()
{
	if [ -n "$GREP_0979" ] ; then
		GREP_0975=0
		GREP_0974="END"
		GREP_1168 "_find_range_init_ _NOT_SEARCH_JUST_CAT_ _search_slice_"
		GREP_0989
	else
		GREP_1168 "_find_range_init_ _search_just_cat_"
		GREP_0987
	fi
}

GREP_1009()
{
	GREP_0958="TO"
	GREP_0972=0
	GREP_0973=$GREP_0980
	GREP_1168 "_find_range_init_ _FROM_FINAL_ searching TO point"
	GREP_0995

	GREP_0975=0
	GREP_0974=$GREP_0973
	GREP_1168 "_find_range_init_ _FROM_FINAL_ _search_slice_"
	GREP_0989
}

GREP_1010()
{
	GREP_0958="FROM"
	GREP_0972=0
	GREP_0973=$GREP_0980
	GREP_1168 "_find_range_init_ _TO_FINAL_ searching FROM point"
	GREP_0995

	GREP_0975=$GREP_0972
	GREP_0974="END"
	GREP_1168 "_find_range_init_ _TO_FINAL_ _search_slice_"
	GREP_0989
}
